function [px,py,pz,wartg] = fk(o1, o2, o3, o4)
%FK forward kinematic function: the parameters are the robot properties
format short
%Robot parameters definition
h = 29;
e = 75;
f = 71;
d = 85;



%Matrices definition
T01 = [cos(o1), 0, sin(o1), h*cos(o1); sin(o1), 0, -cos(o1), h*sin(o1); 0, 1, 0, 0; 0, 0, 0, 1];
T12 = [cos(o2), -sin(o2), 0, e*cos(o2); sin(o2), cos(o2), 0, e*sin(o2); 0, 0, 1, 0; 0, 0, 0, 1];
T23 = [cos(o3), -sin(o3), 0, f*cos(o3); sin(o3), cos(o3), 0, f*sin(o3); 0, 0, 1, 0; 0, 0, 0, 1];
T34 = [cos(o4), -sin(o4), 0, d*cos(o4); sin(o4), cos(o4), 0, d*sin(o4); 0, 0, 1, 0; 0, 0, 0, 1];


T05 = T01*T12*T23*T34;

%Tool position
px = T05(1,4);
py = T05(2,4);
pz = T05(3,4);


T04 = T01*T12*T23;
pxw = T04(1,4);
pyw = T04(2,4);
pzw = T04(3,4);

%Wrist angle rotation to ground
wartg = radtodeg(atan2( T05(3,2),-(cos(o1)*T05(1,2) + sin(o1)*T05(2,2))));

end

