function theta = ik(Po, P, wartg )
%IK1 Summary of this function goes here

format short



%Robot parameters definition
h = 29;
e = 75;
f = 71;
d = 85;

phi = -(wartg - 90);

%1- Calculate the o1 angle
if P(2) - Po(2) < 0
    o1 = radtodeg(atan2(-P(2), -P(1)))-180;
else
    o1 = radtodeg(atan2(P(2), P(1))); 
end

%2- Calculate the wrist position & cosine law
pwx = P(1) - d*cos(degtorad(o1))*sin(degtorad(wartg));
pwy = P(2) - d*sin(degtorad(o1))*sin(degtorad(wartg));
pwz = P(3) - d*cos(degtorad(wartg));
T = pwx*cos(degtorad(o1)) + pwy*sin(degtorad(o1));


%3- Calculate the o2 angle
a = 2*e*(h -T);
b = -2*pwz*e;
c  = f*f -(T*T + h*h + pwz*pwz + e*e - 2*T*h);
o2_0 = radtodeg(atan2(b,a) + atan2(-sqrt(a^2 + b^2 -c^2),c));
o2_1 = radtodeg(atan2(b,a) + atan2(sqrt(a^2 + b^2 -c^2),c));

if o2_1 >= 200 %It should be 360 - o2 offset
    o2_1 = o2_1 - 360;
elseif o2_0 <= -200
    o2_0 = o2_0 + 360;
end


%4- Calculate the o3 angle
%a = pwz - e*sin(degtorad(o2));
%b = T - h - e*cos(degtorad(o2));
%o3 = radtodeg(atan2(a,b)) - o2;

o3_1 = radtodeg(atan2(pwz - e*sin(degtorad(o2_1)),T - h - e*cos(degtorad(o2_1)))) - o2_1;
o3_0 = radtodeg(atan2(pwz - e*sin(degtorad(o2_0)),T - h - e*cos(degtorad(o2_0)))) - o2_0;
if(abs(o3_0) == 360)
    o3_0 = 0;
elseif(abs(o3_1) == 360)
    o3_1 = 0;
end


%5- Calculate the o4 angle
T = P(1)*cos(degtorad(o1)) + P(2)*sin(degtorad(o1));
%b_1 = (cos(degtorad(o2_1 + o3_1))*(T - h - e*cos(degtorad(o2_1))) + sin(degtorad(o2_1 + o3_1))*(P(3) - e*sin(degtorad(o2_1))) - f)/d;
%b_0 = (cos(degtorad(o2_0 + o3_0))*(T - h - e*cos(degtorad(o2_0))) + sin(degtorad(o2_0 + o3_0))*(P(3) - e*sin(degtorad(o2_0))) - f)/d;
%o4_0 = radtodeg(atan2(sqrt(1-b_0*b_0),b_0))
%o4_1 = radtodeg(atan2(sqrt(1-b_1*b_1),b_1))
o4_0 = phi - o2_0 - o3_0;
o4_1 = phi - o2_1 - o3_1;

%
theta = [degtorad(o1) degtorad(o2_0) degtorad(o3_0) degtorad(o4_0);...
    degtorad(o1) degtorad(o2_1) degtorad(o3_1) degtorad(o4_1)];

end
    

